/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#ifndef __PDB_FAT_ITEM_H__
#define __PDB_FAT_ITEM_H__

#include "pdbItem.h"

class pdbFatItem: public pdbItem {
public:
  pdbFatItem(int id) : pdbItem(id) {}
  pdbFatItem(const string& name, int id) : pdbItem(name, id) {}
  virtual ~pdbFatItem() {}
  
  virtual ostream& print(ostream& ostr) const;
  
  void headBegin(const pdbLoc& loc) { pos[0] = loc; }
  void headEnd  (const pdbLoc& loc) { pos[1] = loc; }
  void bodyBegin(const pdbLoc& loc) { pos[2] = loc; }
  void bodyEnd  (const pdbLoc& loc) { pos[3] = loc; }

  const pdbLoc& headBegin(void) const { return pos[0]; }
  const pdbLoc& headEnd  (void) const { return pos[1]; }
  const pdbLoc& bodyBegin(void) const { return pos[2]; }
  const pdbLoc& bodyEnd  (void) const { return pos[3]; }

  virtual void adjustPtrs(PDB*);

protected:
  pdbLoc pos[4];
};

#endif
