/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#ifndef __PDB_MACRO_H__
#define __PDB_MACRO_H__

#include "pdbItem.h"

class pdbMacro : public pdbItem {
public:
  pdbMacro(int id) : pdbItem(id) {}
  pdbMacro(const string& name, int id) : pdbItem(name, id) {}

  virtual const char *desc() const { return "macro"; }
  virtual ostream& print(ostream& ostr) const;
  virtual dupl_t findDuplicate(pdbSimpleItem* r);

  macro_t kind() const { return k; }
  const string& text() const { return t; }

  void kind(macro_t kind) { k = kind; }
  void text(const string& txt) { t = txt; }

private:
  macro_t k;
  string  t;
};

#endif
