/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#ifndef __PDB_NAMESPACE_H__
#define __PDB_NAMESPACE_H__

#include "pdbFatItem.h"

class pdbNamespace : public pdbFatItem {
public:
  pdbNamespace(int id) : pdbFatItem(id), ns(0) {}
  pdbNamespace(const string& name, int id) : pdbFatItem(name, id), ns(0) {}

  virtual const char *desc() const { return "namespace"; }
  virtual ostream& print(ostream& ostr) const;
  virtual void adjustPtrs(PDB* p);
  virtual dupl_t findDuplicate(pdbSimpleItem* r);


  typedef vector<pdbItem *> memvec;

  const memvec& members() const { return m; }
  const pdbNamespace* isAlias() const { return ns; }

  void addMember(pdbItem* item) { m.push_back(item); }
  void isAlias(const pdbNamespace* n) { ns = n; }

private:
  const pdbNamespace *ns;
  memvec              m;
};

#endif
