/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#ifndef __PDB_TEMPLATE_H__
#define __PDB_TEMPLATE_H__

#include "pdbFatItem.h"

class pdbTemplate : public pdbFatItem {
public:
  pdbTemplate(int id) : pdbFatItem(id) {}
  pdbTemplate(const string& name, int id) : pdbFatItem(name, id) {}

  virtual const char *desc() const { return "template"; }
  virtual ostream& print(ostream& ostr) const;
  virtual void process(PDB *p);
  virtual dupl_t findDuplicate(pdbSimpleItem* r);

  templ_t kind() const { return k; }
  const string& text() const { return t; }

  void kind(templ_t kind) { k = kind; }
  void text(const string& txt) { t = txt; }

private:
  templ_t k;
  string  t;
};

#endif
