/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#ifndef __PDB_TEMPLATE_ITEM_H__
#define __PDB_TEMPLATE_ITEM_H__

#include "pdbFatItem.h"

class pdbTemplateItem: public pdbFatItem {
public:
  pdbTemplateItem(int id) : pdbFatItem(id), t(0), isSpecl(false) {}
  pdbTemplateItem(const string& name, int id) : pdbFatItem(name, id),
                  t(0), isSpecl(false) {}
  virtual ~pdbTemplateItem() {}

  virtual ostream& print(ostream& ostr) const;
  virtual void adjustPtrs(PDB* p);

  static const pdbTemplate* TE_UNKNOWN;

  const pdbTemplate *isTemplate() const { return t; }
  bool isSpecialized() const { return isSpecl; }

  void isTemplate(const pdbTemplate *templ) { t = templ; }
  void isSpecialized(bool s) { isSpecl = s; }

protected:
  const pdbTemplate *t;
  bool               isSpecl;
};

#endif
